; routine to send a data byte out the bcr port
; direct connection, no filtering
; S. Adolph
; timing for 57600 baud

; send same character repeated with delay

; send inverted TTL
; start = 1 (zero)
; data is inverted
; stop = 0 (one)

	.org	60000d
	di			; turn off interrupts!
start:	
	mvi	a,'A'		; data		
	call	fascas
	
	mvi	b,255d		; counter
delay:				; delay
	dcr	b
	jnz	delay		
	jmp	start
	


; start bit duration = 7+4+4+4+4+4+4+4+4+4 = 43
; data bit duration  = 4+10+4+4+4+4+4+4+4  = 42
; stop bit duration  = 4+7+4+4+4+4+4+7+4   = 42

; 42.65 clock cycles is ideal

fascas:				; enter with a holding byte to send
				; destroys a, c, b, d, e
				; 1 start, 1 stop, no parity

	xri	11111111b	; invert data
	mov	c,a		; store data	
	mvi	d,01000000b	; or data
	mvi	e,10000000b	; and data
	
sendstart:
	mvi	a,11000000b	; latch one
	sim			; send start bit

	mvi	b,08d
	nop
	nop			; start bit delay

sendloop:			; send 8 bits
	mov	a,c		; get data
	rrc			; rotate bits, get carry status
	mov	c,a		; store data
				; bit is in MSB
	ana	e		; get data bit
	ora	d		; set latch

	nop			; one delay
		
	sim			; send one bit
	dcr	b
	jnz	sendloop
	
sendstop:

	nop
	nop
	nop
	nop
	nop			; last bit delay for 57600

	mvi	a,01000000b	; latch zero
	sim			; send stop bit
	ret
	

	
	.end


	

